const textHighlightConstruct = { name: 'textHighlight', tokenize: textHighlightTokenize }

function textHighlightTokenize (effects, ok, nok) {
  return start

  function start (code) {
    effects.enter('textHighlight')
    effects.enter('textHighlightMarker')
    effects.consume(code)
    effects.consume(code)
    effects.exit('textHighlightMarker')
    effects.enter('textHighlightString')
    effects.enter('chunkString', { contentType: 'string' })
    return begin
  }

  function begin (code) {
    return code === 61 ? nok(code) : inside(code)
  }

  function inside (code) {
    if (code === -5 || code === -4 || code === -3 || code === null) {
      return nok(code)
    }

    if (code === 92) {
      effects.consume(code)
      return insideEscape
    }

    function insideEscape (code) {
      if (code === 92 || code === 61) {
        effects.consume(code)
        return inside
      }

      return inside(code)
    }

    if (code === 61) {
      effects.exit('chunkString')
      effects.exit('textHighlightString')
      effects.enter('textHighlightMarker')
      effects.consume(code)
      effects.consume(code)
      effects.exit('textHighlightMarker')
      effects.exit('textHighlight')
      return ok
    }

    effects.consume(code)
    return inside
  }
}



export const textHighlight = { text: { 61: textHighlightConstruct }  }
